"use strict";
exports.id = 210;
exports.ids = [210];
exports.modules = {

/***/ 31210:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "Z": () => (/* binding */ api_isBoardValid)
});

// EXTERNAL MODULE: ./src/api/isCharacterValid.ts
var isCharacterValid = __webpack_require__(38246);
;// CONCATENATED MODULE: ./src/api/isCellValid.ts

const isCellValid = (cell, config)=>{
    const { isEmpty , tile , x , y  } = cell;
    if (x < 0 || x >= config.boardWidth) {
        return false;
    }
    if (y < 0 || y >= config.boardHeight) {
        return false;
    }
    if (isEmpty && tile !== null) {
        return false;
    }
    if (tile !== null && !(0,isCharacterValid/* default */.Z)(tile.character)) {
        return false;
    }
    return true;
};
/* harmony default export */ const api_isCellValid = (isCellValid);

;// CONCATENATED MODULE: ./src/api/isRowValid.ts

const isRowValid = (row, config)=>{
    if (row.length !== config.boardWidth) {
        return false;
    }
    for (const cell of row){
        if (!api_isCellValid(cell, config)) {
            return false;
        }
    }
    return true;
};
/* harmony default export */ const api_isRowValid = (isRowValid);

;// CONCATENATED MODULE: ./src/api/isBoardValid.ts

const isBoardValid = (board, config)=>{
    if (board.length !== config.boardHeight) {
        return false;
    }
    for (const row of board){
        if (!api_isRowValid(row, config)) {
            return false;
        }
    }
    return areTwoCharacterTilesValid(board, config);
};
const areTwoCharacterTilesValid = (board, config)=>{
    const cells = board.flat().filter((cell)=>cell && cell.tile && config.isTwoCharacterTilePrefix(cell.tile.character));
    for (const cell of cells){
        for (const characters of config.twoCharacterTiles){
            const canCheckDown = cell.y + 1 < board.length;
            const canCheckRight = cell.x + 1 < board[0].length;
            const cellDown = board[cell.y + 1][cell.x];
            const cellRight = board[cell.y][cell.x + 1];
            const collidesDown = canCheckDown && cellDown.tile && cellDown.tile.character === characters[1];
            const collidesRight = canCheckRight && cellRight.tile && cellRight.tile.character === characters[1];
            const collides = collidesDown || collidesRight;
            if (cell.tile && characters.startsWith(cell.tile.character) && collides) {
                return false;
            }
        }
    }
    return true;
};
/* harmony default export */ const api_isBoardValid = (isBoardValid);


/***/ }),

/***/ 38246:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Z": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
const TWO_TILE_CHARACTER_LENGTH = 2;
const MAX_CHARACTER_LENGTH = TWO_TILE_CHARACTER_LENGTH;
const isCharacterValid = (character)=>{
    /*
   * We could be strict here and check whether config.hasCharacter(character) || character === BLANK
   * but since this case won't really affect/break solving, we don't need to worry about it.
   * It's better to display an empty state than error state in UI, so this is a sanity check only.
   */ return character.length !== 0 && character.length <= MAX_CHARACTER_LENGTH;
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (isCharacterValid);


/***/ })

};
;