"use strict";
exports.id = 44;
exports.ids = [44];
exports.modules = {

/***/ 38436:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.VOWELS = exports.CONSONANTS = exports.NO_BONUS = exports.EMPTY_CELL = exports.BONUS_WORD = exports.BONUS_CHARACTER = exports.BLANK = exports.COMMA_LATIN = exports.COMMA_ARABIC = void 0;
exports.COMMA_ARABIC = '،';
exports.COMMA_LATIN = ',';
exports.BLANK = ' ';
exports.BONUS_CHARACTER = 'BONUS_CHARACTER';
exports.BONUS_WORD = 'BONUS_WORD';
exports.EMPTY_CELL = ' ';
exports.NO_BONUS = { characterMultiplier: 1, wordMultiplier: 1 };
exports.CONSONANTS = 'bcćdfghjklłmnńñpqrsśtvwxzźż'.split('');
exports.VOWELS = 'aąäeęioóöuüy'.split('');


/***/ }),

/***/ 21285:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const logger_1 = __importDefault(__webpack_require__(52954));
const types_1 = __webpack_require__(46452);
const fs_1 = __importDefault(__webpack_require__(57147));
const constants_1 = __webpack_require__(75823);
const lib_1 = __webpack_require__(26137);
class Dictionaries {
    constructor() {
        this.cache = new lib_1.LayeredCache();
        this.downloadDictionaryProxies = Object.fromEntries(Object.values(types_1.Locale).map((locale) => [locale, (0, lib_1.createAsyncProxy)(() => (0, lib_1.downloadDictionary)(locale))]));
    }
    async get(locale) {
        if (this.cache.has(locale)) {
            const trie = await this.cache.get(locale);
            if (trie) {
                return trie;
            }
        }
        logger_1.default.info('Dictionaries - cache miss', { locale });
        return this.updateDictionary(locale);
    }
    remove() {
        fs_1.default.rmdirSync(constants_1.OUTPUT_DIRECTORY, { recursive: true });
    }
    async update(force) {
        const locales = force ? Object.values(types_1.Locale) : this.getLocalesToUpdate();
        logger_1.default.info('Dictionaries - update', { force, locales });
        await Promise.all(locales.map((locale) => this.updateDictionary(locale)));
    }
    getLocalesToUpdate() {
        return Object.values(types_1.Locale).filter((locale) => this.cache.isStale(locale) !== false);
    }
    async updateDictionary(locale) {
        logger_1.default.info('Dictionaries - updateDictionary', { locale });
        fs_1.default.mkdirSync(constants_1.OUTPUT_DIRECTORY, { recursive: true });
        const downloadDictionaryProxy = this.downloadDictionaryProxies[locale];
        const trie = await downloadDictionaryProxy();
        await this.cache.set(locale, trie);
        return trie;
    }
}
exports["default"] = Dictionaries;


/***/ }),

/***/ 75823:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.OUTPUT_DIRECTORY = exports.CACHE_STALE_THRESHOLD = exports.DAY = void 0;
const os_1 = __importDefault(__webpack_require__(22037));
const path_1 = __importDefault(__webpack_require__(71017));
exports.DAY = 24 * 60 * 60 * 1000;
exports.CACHE_STALE_THRESHOLD = 1 * exports.DAY; // eslint-disable-line no-implicit-coercion
exports.OUTPUT_DIRECTORY = path_1.default.resolve(os_1.default.homedir(), '.scrabble-solver', 'dictionaries');


/***/ }),

/***/ 89044:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.dictionaries = void 0;
const Dictionaries_1 = __importDefault(__webpack_require__(21285));
__exportStar(__webpack_require__(26137), exports);
exports.dictionaries = new Dictionaries_1.default();


/***/ }),

/***/ 2812:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const trie_1 = __webpack_require__(83140);
const fs_1 = __importDefault(__webpack_require__(57147));
const constants_1 = __webpack_require__(75823);
const getDictionaryFilepath_1 = __importDefault(__webpack_require__(68638));
class DiskCache {
    async get(locale) {
        if (!this.has(locale)) {
            return undefined;
        }
        const filepath = (0, getDictionaryFilepath_1.default)(locale);
        const serialized = await fs_1.default.promises.readFile(filepath, 'utf-8');
        const trie = trie_1.Trie.deserialize(serialized);
        return trie;
    }
    getLastModifiedTimestamp(locale) {
        const filepath = (0, getDictionaryFilepath_1.default)(locale);
        if (!fs_1.default.existsSync(filepath)) {
            return undefined;
        }
        const stats = fs_1.default.statSync(filepath);
        return stats.mtimeMs;
    }
    has(locale) {
        const filepath = (0, getDictionaryFilepath_1.default)(locale);
        return fs_1.default.existsSync(filepath);
    }
    isStale(locale) {
        if (!this.has(locale)) {
            return undefined;
        }
        const lastModifiedTimestamp = this.getLastModifiedTimestamp(locale);
        if (typeof lastModifiedTimestamp === 'undefined') {
            return undefined;
        }
        const timeSinceModification = Math.abs(lastModifiedTimestamp - Date.now());
        return timeSinceModification > constants_1.CACHE_STALE_THRESHOLD;
    }
    async set(locale, trie) {
        const filepath = (0, getDictionaryFilepath_1.default)(locale);
        await fs_1.default.promises.writeFile(filepath, trie.serialize());
    }
}
exports["default"] = DiskCache;


/***/ }),

/***/ 70287:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const createCacheTimestampComparator_1 = __importDefault(__webpack_require__(20494));
const DiskCache_1 = __importDefault(__webpack_require__(2812));
const MemoryCache_1 = __importDefault(__webpack_require__(50192));
class LayeredCache {
    constructor() {
        this.layers = [new MemoryCache_1.default(), new DiskCache_1.default()];
    }
    async get(locale) {
        const cache = this.getLastModifiedLayer(locale);
        if (!cache) {
            return Promise.resolve(undefined);
        }
        const [memoryCache, diskCache] = this.layers;
        const value = await cache.get(locale);
        if (cache === diskCache && typeof value !== 'undefined') {
            await memoryCache.set(locale, value);
        }
        return value;
    }
    getLastModifiedTimestamp(locale) {
        const cache = this.getLastModifiedLayer(locale);
        if (!cache) {
            return undefined;
        }
        return cache.getLastModifiedTimestamp(locale);
    }
    has(locale) {
        return this.layers.some((cache) => cache.has(locale));
    }
    isStale(locale) {
        if (this.layers.some((cache) => cache.isStale(locale))) {
            return true;
        }
        if (this.layers.every((cache) => typeof cache.isStale(locale) === 'undefined')) {
            return undefined;
        }
        return false;
    }
    async set(locale, trie) {
        const [memoryCache, diskCache] = this.layers;
        await diskCache.set(locale, trie);
        await memoryCache.set(locale, trie);
    }
    getLastModifiedLayer(locale) {
        const layers = this.layers.filter((cache) => cache.has(locale));
        const [cached] = [...layers].sort((0, createCacheTimestampComparator_1.default)(locale));
        return cached;
    }
}
exports["default"] = LayeredCache;


/***/ }),

/***/ 50192:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const constants_1 = __webpack_require__(75823);
class MemoryCache {
    constructor() {
        this.cache = {};
        this.cacheTimestamps = {};
    }
    get(locale) {
        return Promise.resolve(this.cache[locale]);
    }
    getLastModifiedTimestamp(locale) {
        return this.cacheTimestamps[locale];
    }
    has(locale) {
        return typeof this.cache[locale] !== 'undefined';
    }
    isStale(locale) {
        const timestamp = this.getLastModifiedTimestamp(locale);
        if (!this.has(locale) || typeof timestamp === 'undefined') {
            return undefined;
        }
        const timeSinceModification = Math.abs(timestamp - Date.now());
        return timeSinceModification > constants_1.CACHE_STALE_THRESHOLD;
    }
    set(locale, trie) {
        this.cacheTimestamps[locale] = Date.now();
        this.cache[locale] = trie;
        return Promise.resolve();
    }
}
exports["default"] = MemoryCache;


/***/ }),

/***/ 26554:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const createAsyncProxy = (asyncCallback) => {
    let promise = null;
    return async () => {
        if (promise) {
            return promise;
        }
        try {
            promise = asyncCallback();
            return await promise;
        }
        finally {
            promise = null;
        }
    };
};
exports["default"] = createAsyncProxy;


/***/ }),

/***/ 20494:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const createCacheTimestampComparator = (locale) => {
    return (a, b) => {
        const aTimestamp = a.getLastModifiedTimestamp(locale);
        const bTimestamp = b.getLastModifiedTimestamp(locale);
        if (aTimestamp === bTimestamp) {
            return 0;
        }
        if (typeof aTimestamp === 'undefined') {
            return 1;
        }
        if (typeof bTimestamp === 'undefined') {
            return -1;
        }
        return bTimestamp - aTimestamp;
    };
};
exports["default"] = createCacheTimestampComparator;


/***/ }),

/***/ 41281:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const trie_1 = __webpack_require__(83140);
const logger_1 = __importDefault(__webpack_require__(52954));
const word_lists_1 = __webpack_require__(51585);
const downloadDictionary = async (locale) => {
    logger_1.default.info('downloadDictionary', { locale });
    const words = await (0, word_lists_1.getWordList)(locale);
    logger_1.default.info('downloadDictionary - success', { locale });
    const trie = trie_1.Trie.fromArray(words);
    return trie;
};
exports["default"] = downloadDictionary;


/***/ }),

/***/ 68638:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const path_1 = __importDefault(__webpack_require__(71017));
const constants_1 = __webpack_require__(75823);
const getDictionaryFilepath = (locale) => {
    return path_1.default.resolve(constants_1.OUTPUT_DIRECTORY, `${locale}.txt`);
};
exports["default"] = getDictionaryFilepath;


/***/ }),

/***/ 26137:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MemoryCache = exports.LayeredCache = exports.getDictionaryFilepath = exports.downloadDictionary = exports.DiskCache = exports.createCacheTimestampComparator = exports.createAsyncProxy = void 0;
var createAsyncProxy_1 = __webpack_require__(26554);
Object.defineProperty(exports, "createAsyncProxy", ({ enumerable: true, get: function () { return __importDefault(createAsyncProxy_1).default; } }));
var createCacheTimestampComparator_1 = __webpack_require__(20494);
Object.defineProperty(exports, "createCacheTimestampComparator", ({ enumerable: true, get: function () { return __importDefault(createCacheTimestampComparator_1).default; } }));
var DiskCache_1 = __webpack_require__(2812);
Object.defineProperty(exports, "DiskCache", ({ enumerable: true, get: function () { return __importDefault(DiskCache_1).default; } }));
var downloadDictionary_1 = __webpack_require__(41281);
Object.defineProperty(exports, "downloadDictionary", ({ enumerable: true, get: function () { return __importDefault(downloadDictionary_1).default; } }));
var getDictionaryFilepath_1 = __webpack_require__(68638);
Object.defineProperty(exports, "getDictionaryFilepath", ({ enumerable: true, get: function () { return __importDefault(getDictionaryFilepath_1).default; } }));
var LayeredCache_1 = __webpack_require__(70287);
Object.defineProperty(exports, "LayeredCache", ({ enumerable: true, get: function () { return __importDefault(LayeredCache_1).default; } }));
var MemoryCache_1 = __webpack_require__(50192);
Object.defineProperty(exports, "MemoryCache", ({ enumerable: true, get: function () { return __importDefault(MemoryCache_1).default; } }));


/***/ }),

/***/ 83017:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const constants_1 = __webpack_require__(38436);
const Cell_1 = __importDefault(__webpack_require__(70902));
const Tile_1 = __importDefault(__webpack_require__(580));
class Board {
    static create(width, height) {
        return Board.fromStringArray(Array(height).fill(Array(width).fill(' ').join('')));
    }
    static fromJson(json) {
        return new Board({
            rows: json.map((row) => row.map(Cell_1.default.fromJson)),
        });
    }
    static fromStringArray(stringArray) {
        return new Board({
            rows: stringArray.map((row, y) => row.split('').map((character, x) => new Cell_1.default({
                isEmpty: !character || character === constants_1.EMPTY_CELL,
                tile: character === constants_1.EMPTY_CELL ? Tile_1.default.Null : new Tile_1.default({ character }),
                x,
                y,
            }))),
        });
    }
    constructor({ rows }) {
        this.rows = rows;
        this.columnsCount = rows[0].length;
        this.rowsCount = rows.length;
    }
    get center() {
        const x = Math.floor(this.columnsCount / 2);
        const y = Math.floor(this.rowsCount / 2);
        return this.rows[y][x];
    }
    clone() {
        const rows = this.rows.map((row) => row.map((cell) => cell.clone()));
        return new Board({ rows });
    }
    collides(cell) {
        return this.collidesUp(cell) || this.collidesDown(cell) || this.collidesLeft(cell) || this.collidesRight(cell);
    }
    collidesDown({ x, y }) {
        return y < this.rowsCount - 1 && !this.rows[y + 1][x].isEmpty;
    }
    collidesLeft({ x, y }) {
        return x > 0 && !this.rows[y][x - 1].isEmpty;
    }
    collidesRight({ x, y }) {
        return x < this.columnsCount - 1 && !this.rows[y][x + 1].isEmpty;
    }
    collidesUp({ x, y }) {
        return y > 0 && !this.rows[y - 1][x].isEmpty;
    }
    equals(other) {
        return (this.columnsCount === other.columnsCount &&
            this.rowsCount === other.rowsCount &&
            this.rows.every((row, rowIndex) => {
                return row.every((cell, cellIndex) => {
                    return cell.equals(other.rows[rowIndex][cellIndex]);
                });
            }));
    }
    getBlanksCount() {
        return this.rows.reduce((count, row) => {
            return count + row.reduce((rowCount, cell) => rowCount + (cell.tile.isBlank ? 1 : 0), 0);
        }, 0);
    }
    getColumn(index) {
        return this.rows.map((row) => row[index]);
    }
    getRow(index) {
        return this.rows[index];
    }
    getTilesCount() {
        return this.rows.reduce((count, row) => {
            return count + row.reduce((rowCount, cell) => rowCount + (cell.hasTile() ? 1 : 0), 0);
        }, 0);
    }
    getWords() {
        const columns = [];
        for (let x = 0; x < this.columnsCount; ++x) {
            const column = [];
            for (let y = 0; y < this.rowsCount; ++y) {
                column.push(this.rows[y][x]);
            }
            columns.push(column);
        }
        const columnsBoard = new Board({ rows: columns });
        const lines = this.toString().split('\n').concat(columnsBoard.toString().split('\n'));
        const words = lines
            .flatMap((line) => line.replaceAll(/\s+/g, constants_1.EMPTY_CELL).split(' '))
            .filter((word) => word.length > 1);
        return words;
    }
    isEmpty() {
        return this.rows.every((row) => row.every(({ isEmpty }) => isEmpty));
    }
    toJson() {
        return this.rows.map((row) => row.map((cell) => cell.toJson()));
    }
    toString() {
        return this.rows.map((row) => row.map(String).join('')).join('\n');
    }
    updateCell(x, y, updateCell) {
        this.rows[y][x] = updateCell(this.rows[y][x]);
    }
    updateRow(y, updateRow) {
        this.rows[y] = updateRow(this.rows[y]);
    }
}
exports["default"] = Board;


/***/ }),

/***/ 28508:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.isBoardJson = void 0;
const CellJson_1 = __webpack_require__(56508);
const isBoardJson = (value) => {
    if (!Array.isArray(value)) {
        return false;
    }
    for (const row of value) {
        if (!Array.isArray(value)) {
            return false;
        }
        for (const cell of row) {
            if (!(0, CellJson_1.isCellJson)(cell)) {
                return false;
            }
        }
    }
    return true;
};
exports.isBoardJson = isBoardJson;


/***/ }),

/***/ 80769:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
class Bonus {
    constructor({ multiplier, score, x, y }) {
        this.multiplier = multiplier;
        this.score = score;
        this.x = x;
        this.y = y;
    }
    canApply(_config, cell) {
        return cell.isEmpty && this.matchesCellCoordinates(cell);
    }
    matchesCellCoordinates(cell) {
        return this.x === cell.x && this.y === cell.y;
    }
    toJson() {
        return {
            multiplier: this.multiplier,
            score: this.score,
            type: this.type,
            x: this.x,
            y: this.y,
        };
    }
    get value() {
        return {
            characterMultiplier: 1,
            wordMultiplier: 1,
        };
    }
}
exports["default"] = Bonus;


/***/ }),

/***/ 70902:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Tile_1 = __importDefault(__webpack_require__(580));
class Cell {
    static fromJson(json) {
        return new Cell({
            isEmpty: json.isEmpty,
            tile: Tile_1.default.fromJson(json.tile),
            x: json.x,
            y: json.y,
        });
    }
    // eslint-disable-next-line no-undef
    constructor({ isEmpty = true, tile = Tile_1.default.Null, x, y }) {
        this.isEmpty = isEmpty;
        this.tile = tile;
        this.x = x;
        this.y = y;
    }
    clone() {
        return new Cell({
            isEmpty: this.isEmpty,
            tile: this.tile.clone(),
            x: this.x,
            y: this.y,
        });
    }
    equals(other) {
        return this.x === other.x && this.y === other.y && this.isEmpty === other.isEmpty && this.tile.equals(other.tile);
    }
    hasTile() {
        return this.tile !== Tile_1.default.Null;
    }
    isCandidate() {
        return this.isEmpty && this.hasTile();
    }
    toJson() {
        return {
            isEmpty: this.isEmpty,
            tile: this.tile.toJson(),
            x: this.x,
            y: this.y,
        };
    }
    toString() {
        return this.tile.toString();
    }
}
exports["default"] = Cell;


/***/ }),

/***/ 56508:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.isCellJson = void 0;
const isObject_1 = __importDefault(__webpack_require__(93518));
const TileJson_1 = __webpack_require__(92298);
const isCellJson = (value) => {
    return ((0, isObject_1.default)(value) &&
        typeof value.isEmpty === 'boolean' &&
        ((0, TileJson_1.isTileJson)(value.tile) || value.tile === null) &&
        typeof value.x === 'number' &&
        typeof value.y === 'number');
};
exports.isCellJson = isCellJson;


/***/ }),

/***/ 95699:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const constants_1 = __webpack_require__(38436);
const Bonus_1 = __importDefault(__webpack_require__(80769));
class CharacterBonus extends Bonus_1.default {
    constructor() {
        super(...arguments);
        this.type = constants_1.BONUS_CHARACTER;
    }
    canApply(config, cell) {
        return super.canApply(config, cell) && this.matchesCellTileScore(config, cell);
    }
    matchesCellTileScore(config, cell) {
        if (typeof this.score === 'undefined') {
            return true;
        }
        return this.score === config.pointsMap[cell.tile.character];
    }
    get value() {
        return {
            characterMultiplier: this.multiplier,
            wordMultiplier: 1,
        };
    }
}
exports["default"] = CharacterBonus;


/***/ }),

/***/ 68725:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const constants_1 = __webpack_require__(38436);
const CharacterBonus_1 = __importDefault(__webpack_require__(95699));
const WordBonus_1 = __importDefault(__webpack_require__(39667));
class Config {
    static fromJson(json) {
        return new Config(json);
    }
    constructor(config) {
        this.bonuses = getBonuses(config);
        this.config = config;
        this.pointsMap = getPointsMap(this.config);
    }
    get allTilesBonusScore() {
        return this.config.allTilesBonusScore;
    }
    get alphabet() {
        return getAlphabet(this.config);
    }
    get blankScore() {
        return this.config.blankScore;
    }
    get blanksCount() {
        return this.config.blanksCount;
    }
    get boardHeight() {
        return this.config.boardHeight;
    }
    get boardWidth() {
        return this.config.boardWidth;
    }
    get game() {
        return this.config.game;
    }
    get locale() {
        return this.config.locale;
    }
    get twoCharacterTiles() {
        return this.config.tiles.filter((tile) => tile.character.length === 2).map((tile) => tile.character);
    }
    getCellBonus(cell) {
        return this.bonuses.find((bonus) => bonus.matchesCellCoordinates(cell));
    }
    getCellBonusValue(cell) {
        return this.getCellBonus(cell)?.value || constants_1.NO_BONUS;
    }
    getCharacterPoints(character) {
        if (character === null) {
            return undefined;
        }
        if (character === constants_1.BLANK) {
            return this.blankScore;
        }
        return this.pointsMap[character];
    }
    getTwoCharacterTileByPrefix(character) {
        if (character.length !== 1) {
            return undefined;
        }
        return this.twoCharacterTiles.find((characters) => characters.startsWith(character));
    }
    getTilePoints(tile) {
        if (tile === null) {
            return undefined;
        }
        return tile.isBlank ? this.blankScore : this.getCharacterPoints(tile.character);
    }
    hasCharacter(character) {
        return character in this.pointsMap;
    }
    isTwoCharacterTilePrefix(character) {
        return typeof this.getTwoCharacterTileByPrefix(character) !== 'undefined';
    }
    get maximumCharactersCount() {
        return this.config.maximumCharactersCount;
    }
    get tiles() {
        return this.config.tiles;
    }
    toJson() {
        return this.config;
    }
}
const getBonuses = (config) => {
    return config.bonuses.map((bonus) => {
        if (bonus.type === constants_1.BONUS_CHARACTER) {
            return new CharacterBonus_1.default(bonus);
        }
        if (bonus.type === constants_1.BONUS_WORD) {
            return new WordBonus_1.default(bonus);
        }
        throw new Error(`Unsupported Bonus type: "${bonus.type}"`);
    });
};
const getAlphabet = (config) => config.tiles.map(({ character }) => character);
const getPointsMap = (config) => config.tiles.reduce((pointsMap, { character, score }) => ({
    ...pointsMap,
    [character]: score,
}), {});
exports["default"] = Config;


/***/ }),

/***/ 79238:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Pattern_1 = __importDefault(__webpack_require__(43600));
class FinalPattern extends Pattern_1.default {
    constructor(pattern) {
        super(pattern.board, pattern.cells);
        this.collisions = pattern.getCollisions();
    }
    getCollisions() {
        return this.collisions;
    }
}
exports["default"] = FinalPattern;


/***/ }),

/***/ 47659:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.isGame = void 0;
var Game;
(function (Game) {
    Game["Literaki"] = "literaki";
    Game["Scrabble"] = "scrabble";
    Game["SuperScrabble"] = "super-scrabble";
})(Game || (Game = {}));
const games = Object.values(Game);
const isGame = (locale) => games.includes(locale);
exports.isGame = isGame;
exports["default"] = Game;


/***/ }),

/***/ 44405:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Pattern_1 = __importDefault(__webpack_require__(43600));
class HorizontalPattern extends Pattern_1.default {
    clone() {
        return new HorizontalPattern(this.board, this.cells.map((cell) => cell.clone()));
    }
    getCollisions() {
        const collisions = [];
        this.cells
            .filter((cell) => cell.isEmpty && (this.board.collidesUp(cell) || this.board.collidesDown(cell)))
            .forEach((cell) => {
            const column = this.board.getColumn(cell.x);
            let y = cell.y - 1;
            while (y >= 0 && column[y].hasTile()) {
                --y;
            }
            const previousCells = column.slice(y + 1, cell.y);
            y = cell.y + 1;
            while (y < column.length && column[y].hasTile()) {
                ++y;
            }
            const nextCells = column.slice(cell.y + 1, y);
            const cells = [...previousCells, cell, ...nextCells];
            if (cells.length > 1) {
                const pattern = new Pattern_1.default(this.board, cells);
                collisions.push(pattern);
            }
        });
        return collisions;
    }
}
exports["default"] = HorizontalPattern;


/***/ }),

/***/ 28044:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.isLocale = void 0;
/**
 * Locales are defined using IETF language tags
 * @see https://en.wikipedia.org/wiki/IETF_language_tag
 * @see https://en.wikipedia.org/wiki/ISO_3166-1
 */
var Locale;
(function (Locale) {
    Locale["DE_DE"] = "de-DE";
    Locale["EN_GB"] = "en-GB";
    Locale["EN_US"] = "en-US";
    Locale["ES_ES"] = "es-ES";
    Locale["FA_IR"] = "fa-IR";
    Locale["FR_FR"] = "fr-FR";
    Locale["PL_PL"] = "pl-PL";
    Locale["RO_RO"] = "ro-RO";
})(Locale || (Locale = {}));
const locales = Object.values(Locale);
const isLocale = (locale) => locales.includes(locale);
exports.isLocale = isLocale;
exports["default"] = Locale;


/***/ }),

/***/ 43600:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
class Pattern {
    constructor(board, cells) {
        this.board = board;
        this.cells = cells;
    }
    canBePlaced(config) {
        const emptyCellsCount = this.getEmptyCellsCount();
        const isUsedCellsCountInRange = emptyCellsCount >= 1 && emptyCellsCount <= config.maximumCharactersCount;
        return (isUsedCellsCountInRange &&
            (this.hasAtLeast1NonEmptyCell() || this.collides() || (this.goesThroughBoardCenter() && this.board.isEmpty())));
    }
    clone() {
        return new Pattern(this.board, this.cells.map((cell) => cell.clone()));
    }
    collides() {
        return this.cells.some((cell) => cell.isEmpty && this.board.collides(cell));
    }
    getIndexOfFirstCellWithoutTile() {
        return this.cells.findIndex((cell) => !cell.hasTile());
    }
    getEmptyCellsCount() {
        return this.cells.filter((cell) => cell.isEmpty).length;
    }
    goesThroughBoardCenter() {
        return this.cells.some((cell) => cell.x === this.board.center.x && cell.y === this.board.center.y && cell.isEmpty);
    }
    hasAtLeast1EmptyCell() {
        return this.cells.some((cell) => cell.isEmpty);
    }
    hasAtLeast1NonEmptyCell() {
        return this.cells.some((cell) => !cell.isEmpty);
    }
    getCollisions() {
        return [];
    }
    toJson() {
        return {
            cells: this.cells.map((cell) => cell.toJson()),
            collisions: this.getCollisions().map((collision) => collision.toJson()),
            word: this.toString(),
        };
    }
    toString() {
        return this.cells.reduce((result, cell) => result + cell.toString(), '');
    }
}
exports["default"] = Pattern;


/***/ }),

/***/ 28211:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const constants_1 = __webpack_require__(38436);
const Cell_1 = __importDefault(__webpack_require__(70902));
class Result {
    static fromJson(json) {
        return new Result({
            id: json.id,
            cells: json.cells.map(Cell_1.default.fromJson),
            collisions: json.collisions.map((collision) => collision.map(Cell_1.default.fromJson)),
            points: json.points,
        });
    }
    constructor({ cells, id, collisions, points, }) {
        const tiles = getTiles(cells);
        this.blanksCount = getBlanks(tiles).length;
        this.cells = cells;
        this.collisions = collisions;
        this.consonantsCount = getConsonants(tiles).length;
        this.id = id;
        this.length = cells.length;
        this.points = points;
        this.pointsRatio = getPointsRatio(tiles, points);
        this.tiles = tiles;
        this.tilesCount = tiles.length;
        this.vowelsCount = getVowels(tiles).length;
        this.word = getWord(cells);
        this.words = getWords(cells, collisions);
        this.wordsCount = 1 + this.collisions.length;
    }
    toJson() {
        return {
            cells: this.cells.map((cell) => cell.toJson()),
            id: this.id,
            collisions: this.collisions.map((collision) => collision.map((cell) => cell.toJson())),
            points: this.points,
        };
    }
}
const getBlanks = (tiles) => tiles.filter(({ isBlank }) => isBlank);
const getConsonants = (tiles) => tiles.filter(isConsonant);
const getVowels = (tiles) => tiles.filter(isVowel);
const getPointsRatio = (tiles, points) => points / tiles.length;
const getTiles = (cells) => cells.filter(({ isEmpty }) => isEmpty).map(({ tile }) => tile);
// eslint-disable-next-line prefer-template
const getWord = (cells) => cells.reduce((word, cell) => word + cell.toString(), '');
const getWords = (cells, collisions) => [cells, ...collisions].map(getWord);
const isConsonant = ({ character, isBlank }) => constants_1.CONSONANTS.includes(character) && !isBlank;
const isVowel = ({ character, isBlank }) => constants_1.VOWELS.includes(character) && !isBlank;
exports["default"] = Result;


/***/ }),

/***/ 580:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const constants_1 = __webpack_require__(38436);
class Tile {
    static fromJson(json) {
        if (!json) {
            return Tile.Null;
        }
        return new Tile({
            character: json.character,
            isBlank: json.isBlank,
        });
    }
    constructor({ character, isBlank = false }) {
        this.character = character;
        this.isBlank = isBlank;
    }
    clone() {
        return new Tile({
            character: this.character,
            isBlank: this.isBlank,
        });
    }
    equals(other) {
        return this.character === other.character && this.isBlank === other.isBlank;
    }
    toJson() {
        return {
            character: this.character,
            isBlank: this.isBlank,
        };
    }
    toString() {
        return this.character;
    }
}
Tile.Null = Object.freeze({
    character: constants_1.EMPTY_CELL,
    isBlank: false,
    clone: () => Tile.Null,
    equals: (other) => other === Tile.Null,
    toJson: () => null,
    toString: () => constants_1.EMPTY_CELL,
});
exports["default"] = Tile;


/***/ }),

/***/ 92298:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.isTileJson = void 0;
const isObject_1 = __importDefault(__webpack_require__(93518));
const isTileJson = (value) => {
    return (0, isObject_1.default)(value) && typeof value.character === 'string' && typeof value.isBlank === 'boolean';
};
exports.isTileJson = isTileJson;


/***/ }),

/***/ 36161:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Pattern_1 = __importDefault(__webpack_require__(43600));
class VerticalPattern extends Pattern_1.default {
    clone() {
        return new VerticalPattern(this.board, this.cells.map((cell) => cell.clone()));
    }
    getCollisions() {
        const collisions = [];
        this.cells
            .filter((cell) => cell.isEmpty && (this.board.collidesLeft(cell) || this.board.collidesRight(cell)))
            .forEach((cell) => {
            const row = this.board.getRow(cell.y);
            let x = cell.x - 1;
            while (x >= 0 && row[x].hasTile()) {
                --x;
            }
            const previousCells = row.slice(x + 1, cell.x);
            x = cell.x + 1;
            while (x < row.length && row[x].hasTile()) {
                ++x;
            }
            const nextCells = row.slice(cell.x + 1, x);
            const cells = [...previousCells, cell, ...nextCells];
            if (cells.length > 1) {
                const pattern = new Pattern_1.default(this.board, cells);
                collisions.push(pattern);
            }
        });
        return collisions;
    }
}
exports["default"] = VerticalPattern;


/***/ }),

/***/ 39667:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const constants_1 = __webpack_require__(38436);
const Bonus_1 = __importDefault(__webpack_require__(80769));
class WordBonus extends Bonus_1.default {
    constructor() {
        super(...arguments);
        this.type = constants_1.BONUS_WORD;
    }
    get value() {
        return {
            characterMultiplier: 1,
            wordMultiplier: this.multiplier,
        };
    }
}
exports["default"] = WordBonus;


/***/ }),

/***/ 43184:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
class WordDefinition {
    static fromJson(json) {
        if (!json) {
            return WordDefinition.Null;
        }
        return new WordDefinition({
            definitions: json.definitions,
            exists: json.exists,
            isAllowed: json.isAllowed,
            word: json.word,
        });
    }
    constructor({ definitions, exists, isAllowed, word }) {
        this.definitions = definitions;
        this.exists = exists;
        this.isAllowed = isAllowed;
        this.word = word;
    }
    toJson() {
        return {
            definitions: this.definitions,
            exists: this.exists,
            isAllowed: this.isAllowed,
            word: this.word,
        };
    }
}
WordDefinition.Null = Object.freeze({
    definitions: [],
    exists: false,
    isAllowed: false,
    word: '',
    toJson: () => null,
});
exports["default"] = WordDefinition;


/***/ }),

/***/ 46452:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.isObject = exports.isError = exports.WordDefinition = exports.WordBonus = exports.VerticalPattern = exports.isTileJson = exports.Tile = exports.Result = exports.Pattern = exports.isLocale = exports.Locale = exports.HorizontalPattern = exports.isGame = exports.Game = exports.FinalPattern = exports.Config = exports.CharacterBonus = exports.isCellJson = exports.Cell = exports.Bonus = exports.isBoardJson = exports.Board = void 0;
var Board_1 = __webpack_require__(83017);
Object.defineProperty(exports, "Board", ({ enumerable: true, get: function () { return __importDefault(Board_1).default; } }));
var BoardJson_1 = __webpack_require__(28508);
Object.defineProperty(exports, "isBoardJson", ({ enumerable: true, get: function () { return BoardJson_1.isBoardJson; } }));
var Bonus_1 = __webpack_require__(80769);
Object.defineProperty(exports, "Bonus", ({ enumerable: true, get: function () { return __importDefault(Bonus_1).default; } }));
var Cell_1 = __webpack_require__(70902);
Object.defineProperty(exports, "Cell", ({ enumerable: true, get: function () { return __importDefault(Cell_1).default; } }));
var CellJson_1 = __webpack_require__(56508);
Object.defineProperty(exports, "isCellJson", ({ enumerable: true, get: function () { return CellJson_1.isCellJson; } }));
var CharacterBonus_1 = __webpack_require__(95699);
Object.defineProperty(exports, "CharacterBonus", ({ enumerable: true, get: function () { return __importDefault(CharacterBonus_1).default; } }));
var Config_1 = __webpack_require__(68725);
Object.defineProperty(exports, "Config", ({ enumerable: true, get: function () { return __importDefault(Config_1).default; } }));
var FinalPattern_1 = __webpack_require__(79238);
Object.defineProperty(exports, "FinalPattern", ({ enumerable: true, get: function () { return __importDefault(FinalPattern_1).default; } }));
var Game_1 = __webpack_require__(47659);
Object.defineProperty(exports, "Game", ({ enumerable: true, get: function () { return __importDefault(Game_1).default; } }));
Object.defineProperty(exports, "isGame", ({ enumerable: true, get: function () { return Game_1.isGame; } }));
var HorizontalPattern_1 = __webpack_require__(44405);
Object.defineProperty(exports, "HorizontalPattern", ({ enumerable: true, get: function () { return __importDefault(HorizontalPattern_1).default; } }));
var Locale_1 = __webpack_require__(28044);
Object.defineProperty(exports, "Locale", ({ enumerable: true, get: function () { return __importDefault(Locale_1).default; } }));
Object.defineProperty(exports, "isLocale", ({ enumerable: true, get: function () { return Locale_1.isLocale; } }));
var Pattern_1 = __webpack_require__(43600);
Object.defineProperty(exports, "Pattern", ({ enumerable: true, get: function () { return __importDefault(Pattern_1).default; } }));
var Result_1 = __webpack_require__(28211);
Object.defineProperty(exports, "Result", ({ enumerable: true, get: function () { return __importDefault(Result_1).default; } }));
var Tile_1 = __webpack_require__(580);
Object.defineProperty(exports, "Tile", ({ enumerable: true, get: function () { return __importDefault(Tile_1).default; } }));
var TileJson_1 = __webpack_require__(92298);
Object.defineProperty(exports, "isTileJson", ({ enumerable: true, get: function () { return TileJson_1.isTileJson; } }));
var VerticalPattern_1 = __webpack_require__(36161);
Object.defineProperty(exports, "VerticalPattern", ({ enumerable: true, get: function () { return __importDefault(VerticalPattern_1).default; } }));
var WordBonus_1 = __webpack_require__(39667);
Object.defineProperty(exports, "WordBonus", ({ enumerable: true, get: function () { return __importDefault(WordBonus_1).default; } }));
var WordDefinition_1 = __webpack_require__(43184);
Object.defineProperty(exports, "WordDefinition", ({ enumerable: true, get: function () { return __importDefault(WordDefinition_1).default; } }));
var isError_1 = __webpack_require__(24075);
Object.defineProperty(exports, "isError", ({ enumerable: true, get: function () { return __importDefault(isError_1).default; } }));
var isObject_1 = __webpack_require__(93518);
Object.defineProperty(exports, "isObject", ({ enumerable: true, get: function () { return __importDefault(isObject_1).default; } }));


/***/ }),

/***/ 24075:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const isObject_1 = __importDefault(__webpack_require__(93518));
const isError = (value) => {
    if (!(0, isObject_1.default)(value)) {
        return false;
    }
    return typeof value.message === 'string';
};
exports["default"] = isError;


/***/ }),

/***/ 93518:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const isObject = (value) => {
    return typeof value === 'object' && value !== null;
};
exports["default"] = isObject;


/***/ }),

/***/ 61704:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const types_1 = __webpack_require__(46452);
const lib_1 = __webpack_require__(60337);
const FILE_URL = 'https://raw.githubusercontent.com/hippler/german-wordlist/master/words.txt';
const getDeDeWordList = async () => {
    return (0, lib_1.getTxtWordList)(FILE_URL, types_1.Locale.DE_DE);
};
exports["default"] = getDeDeWordList;


/***/ }),

/***/ 3284:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const types_1 = __webpack_require__(46452);
const lib_1 = __webpack_require__(60337);
const FILE_URL = 'https://www.wordgamedictionary.com/sowpods/download/sowpods.txt';
const getEnGbWordList = async () => {
    return (0, lib_1.getTxtWordList)(FILE_URL, types_1.Locale.EN_GB);
};
exports["default"] = getEnGbWordList;


/***/ }),

/***/ 163:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const types_1 = __webpack_require__(46452);
const lib_1 = __webpack_require__(60337);
const FILE_URL = 'https://www.wordgamedictionary.com/twl06/download/twl06.txt';
const getEnUsWordList = async () => {
    return (0, lib_1.getTxtWordList)(FILE_URL, types_1.Locale.EN_US);
};
exports["default"] = getEnUsWordList;


/***/ }),

/***/ 87537:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const types_1 = __webpack_require__(46452);
const latinize_1 = __importDefault(__webpack_require__(66761));
const lib_1 = __webpack_require__(60337);
const FILE_URL = 'https://raw.githubusercontent.com/kamilmielnik/scrabble-dictionaries/master/spanish/fise-2.txt';
const N_PLACEHOLDER = '---n---';
const getEsEsWordList = async () => {
    const words = await (0, lib_1.getTxtWordList)(FILE_URL, types_1.Locale.ES_ES);
    return words
        .map((word) => word.replaceAll('ñ', N_PLACEHOLDER))
        .map(latinize_1.default)
        .map((word) => word.replaceAll(N_PLACEHOLDER, 'ñ'));
};
exports["default"] = getEsEsWordList;


/***/ }),

/***/ 29596:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const types_1 = __webpack_require__(46452);
const lib_1 = __webpack_require__(60337);
const FILE_URL = 'https://raw.githubusercontent.com/MansourM/persian-to-persian-dictionary/main/moein/words.txt';
const getFaIrWordList = async () => {
    return (0, lib_1.getTxtWordList)(FILE_URL, types_1.Locale.FA_IR);
};
exports["default"] = getFaIrWordList;


/***/ }),

/***/ 27098:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const types_1 = __webpack_require__(46452);
const lib_1 = __webpack_require__(60337);
const FILE_URL = 'https://raw.githubusercontent.com/Thecoolsim/French-Scrabble-ODS8/main/French%20ODS%20dictionary.txt';
const getFrFrWordList = async () => {
    const words = await (0, lib_1.getTxtWordList)(FILE_URL, types_1.Locale.FR_FR);
    return (0, lib_1.latinizeDiacritics)(words);
};
exports["default"] = getFrFrWordList;


/***/ }),

/***/ 9385:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const cheerio_1 = __webpack_require__(55473);
const fs_1 = __importDefault(__webpack_require__(57147));
const url_1 = __webpack_require__(57310);
const lib_1 = __webpack_require__(60337);
const PAGE_URL = 'https://sjp.pl/sl/growy/';
const FILE_TO_EXTRACT_FROM_ZIP = 'slowa.txt';
const getPlPlWordList = async () => {
    const tempFilepath = (0, lib_1.getTempFilepath)();
    const zipUrl = await fetchZipUrl(PAGE_URL);
    const zipTempFilename = await (0, lib_1.downloadFile)(zipUrl);
    await (0, lib_1.unzip)(zipTempFilename, FILE_TO_EXTRACT_FROM_ZIP, tempFilepath);
    fs_1.default.unlinkSync(zipTempFilename);
    const file = fs_1.default.readFileSync(tempFilepath, 'utf-8');
    fs_1.default.unlinkSync(tempFilepath);
    const words = (0, lib_1.extractWords)(file.toLocaleString(), 'pl-PL');
    return words;
};
const fetchZipUrl = async (url) => {
    const html = await (0, lib_1.downloadHtml)(url);
    const filename = await parseZipContainingPage(html);
    const { href } = new url_1.URL(filename, url);
    return href;
};
const parseZipContainingPage = (html) => {
    const $ = (0, cheerio_1.load)(html);
    const $links = $('a');
    const links = Array.from($links)
        .map((link) => $(link).attr('href'))
        .filter(Boolean);
    const zipFilename = links.find((link) => link.endsWith('.zip'));
    if (typeof zipFilename === 'undefined') {
        throw new Error('Cannot find link to zip file on the page');
    }
    return zipFilename;
};
exports["default"] = getPlPlWordList;


/***/ }),

/***/ 73691:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const types_1 = __webpack_require__(46452);
const lib_1 = __webpack_require__(60337);
const FILE_URL = 'https://raw.githubusercontent.com/kamilmielnik/scrabble-dictionaries/master/romanian/loc-5.0.txt';
const getRoRoWordList = async () => {
    const words = await (0, lib_1.getTxtWordList)(FILE_URL, types_1.Locale.RO_RO);
    return (0, lib_1.latinizeDiacritics)(words);
};
exports["default"] = getRoRoWordList;


/***/ }),

/***/ 8769:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const types_1 = __webpack_require__(46452);
const getDeDeWordList_1 = __importDefault(__webpack_require__(61704));
const getEnGbWordList_1 = __importDefault(__webpack_require__(3284));
const getEnUsWordList_1 = __importDefault(__webpack_require__(163));
const getEsEsWordList_1 = __importDefault(__webpack_require__(87537));
const getFaIrWordList_1 = __importDefault(__webpack_require__(29596));
const getFrFrWordList_1 = __importDefault(__webpack_require__(27098));
const getPlPlWordList_1 = __importDefault(__webpack_require__(9385));
const getRoRoWordList_1 = __importDefault(__webpack_require__(73691));
const localeMap = {
    [types_1.Locale.DE_DE]: getDeDeWordList_1.default,
    [types_1.Locale.EN_GB]: getEnGbWordList_1.default,
    [types_1.Locale.EN_US]: getEnUsWordList_1.default,
    [types_1.Locale.ES_ES]: getEsEsWordList_1.default,
    [types_1.Locale.FA_IR]: getFaIrWordList_1.default,
    [types_1.Locale.FR_FR]: getFrFrWordList_1.default,
    [types_1.Locale.PL_PL]: getPlPlWordList_1.default,
    [types_1.Locale.RO_RO]: getRoRoWordList_1.default,
};
const getWordList = (locale) => localeMap[locale]();
exports["default"] = getWordList;


/***/ }),

/***/ 51585:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.getWordList = exports.getDeDeWordList = exports.getPlPlWordList = exports.getFrFrWordList = exports.getEnGbWordList = exports.getEnUsWordList = void 0;
var getEnUsWordList_1 = __webpack_require__(163);
Object.defineProperty(exports, "getEnUsWordList", ({ enumerable: true, get: function () { return __importDefault(getEnUsWordList_1).default; } }));
var getEnGbWordList_1 = __webpack_require__(3284);
Object.defineProperty(exports, "getEnGbWordList", ({ enumerable: true, get: function () { return __importDefault(getEnGbWordList_1).default; } }));
var getFrFrWordList_1 = __webpack_require__(27098);
Object.defineProperty(exports, "getFrFrWordList", ({ enumerable: true, get: function () { return __importDefault(getFrFrWordList_1).default; } }));
var getPlPlWordList_1 = __webpack_require__(9385);
Object.defineProperty(exports, "getPlPlWordList", ({ enumerable: true, get: function () { return __importDefault(getPlPlWordList_1).default; } }));
var getDeDeWordList_1 = __webpack_require__(61704);
Object.defineProperty(exports, "getDeDeWordList", ({ enumerable: true, get: function () { return __importDefault(getDeDeWordList_1).default; } }));
var getWordList_1 = __webpack_require__(8769);
Object.defineProperty(exports, "getWordList", ({ enumerable: true, get: function () { return __importDefault(getWordList_1).default; } }));
__exportStar(__webpack_require__(60337), exports);


/***/ }),

/***/ 920:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const follow_redirects_1 = __webpack_require__(24396);
const fs_1 = __importDefault(__webpack_require__(57147));
const getTempFilepath_1 = __importDefault(__webpack_require__(5026));
const downloadFile = (url) => {
    return new Promise((resolve, reject) => {
        const tempFilepath = (0, getTempFilepath_1.default)();
        const protocol = url.startsWith('https') ? follow_redirects_1.https : follow_redirects_1.http;
        const writeStream = fs_1.default.createWriteStream(tempFilepath);
        const request = protocol.get(url, (response) => {
            if (typeof response.statusCode === 'undefined' || response.statusCode >= 400) {
                reject(new Error(`Cannot download file: ${url}`));
                return;
            }
            response.on('error', (error) => {
                writeStream.close();
                reject(error);
            });
            response.on('end', () => {
                writeStream.on('finish', () => {
                    writeStream.close();
                    resolve(tempFilepath);
                });
            });
            response.pipe(writeStream);
        });
        request.on('error', (error) => {
            writeStream.close();
            reject(error);
        });
    });
};
exports["default"] = downloadFile;


/***/ }),

/***/ 78015:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const follow_redirects_1 = __webpack_require__(24396);
const downloadHtml = (url) => {
    return new Promise((resolve, reject) => {
        const protocol = url.startsWith('https') ? follow_redirects_1.https : follow_redirects_1.http;
        protocol.get(url, (response) => {
            let data = '';
            response.setEncoding('utf8');
            response.on('data', (chunk) => {
                data += chunk;
            });
            response.on('end', () => {
                resolve(data);
            });
            response.on('error', reject);
        });
    });
};
exports["default"] = downloadHtml;


/***/ }),

/***/ 39759:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const findFirstWordIndex_1 = __importDefault(__webpack_require__(47669));
const extractWords = (file, locale) => {
    const lines = file.split(/\r?\n/g);
    const firstWordIndex = (0, findFirstWordIndex_1.default)(lines, locale);
    const words = [];
    for (let i = firstWordIndex; i < lines.length; ++i) {
        const trimmed = lines[i].trim();
        if (trimmed.length > 0) {
            words.push(trimmed.toLocaleLowerCase());
        }
    }
    return words;
};
exports["default"] = extractWords;


/***/ }),

/***/ 47669:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const findFirstWordIndex = (lines, locale) => {
    const firstWordIndex = lines.findIndex((line, index) => {
        const nextLine = line[index + 1] || '';
        const isNextLineInOrder = line.localeCompare(nextLine, locale) > 0;
        const hasWhitespace = Boolean(line.match(/\s/));
        const isEmpty = line.trim().length === 0;
        return !isEmpty && !hasWhitespace && isNextLineInOrder;
    });
    if (typeof firstWordIndex === 'undefined') {
        throw new Error('Cannot find index of the first word in the file');
    }
    return firstWordIndex;
};
exports["default"] = findFirstWordIndex;


/***/ }),

/***/ 93938:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const crypto_1 = __importDefault(__webpack_require__(6113));
const getHash = (bytes = 8) => crypto_1.default.randomBytes(bytes).toString('hex');
exports["default"] = getHash;


/***/ }),

/***/ 5026:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const os_1 = __importDefault(__webpack_require__(22037));
const path_1 = __importDefault(__webpack_require__(71017));
const getHash_1 = __importDefault(__webpack_require__(93938));
const OUTPUT_DIRECTORY = path_1.default.resolve(os_1.default.homedir(), '.scrabble-solver');
const getTempFilepath = () => {
    const filename = `${(0, getHash_1.default)()}.txt`;
    return path_1.default.join(OUTPUT_DIRECTORY, filename);
};
exports["default"] = getTempFilepath;


/***/ }),

/***/ 78029:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const fs_1 = __importDefault(__webpack_require__(57147));
const downloadFile_1 = __importDefault(__webpack_require__(920));
const extractWords_1 = __importDefault(__webpack_require__(39759));
const getTxtWordList = async (url, locale) => {
    const tempFilename = await (0, downloadFile_1.default)(url);
    const file = fs_1.default.readFileSync(tempFilename, 'utf-8');
    const words = (0, extractWords_1.default)(file.toLocaleString(), locale);
    fs_1.default.unlinkSync(tempFilename);
    return words;
};
exports["default"] = getTxtWordList;


/***/ }),

/***/ 60337:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.unzip = exports.unique = exports.latinizeDiacritics = exports.getTxtWordList = exports.getTempFilepath = exports.getHash = exports.findFirstWordIndex = exports.extractWords = exports.downloadHtml = exports.downloadFile = void 0;
var downloadFile_1 = __webpack_require__(920);
Object.defineProperty(exports, "downloadFile", ({ enumerable: true, get: function () { return __importDefault(downloadFile_1).default; } }));
var downloadHtml_1 = __webpack_require__(78015);
Object.defineProperty(exports, "downloadHtml", ({ enumerable: true, get: function () { return __importDefault(downloadHtml_1).default; } }));
var extractWords_1 = __webpack_require__(39759);
Object.defineProperty(exports, "extractWords", ({ enumerable: true, get: function () { return __importDefault(extractWords_1).default; } }));
var findFirstWordIndex_1 = __webpack_require__(47669);
Object.defineProperty(exports, "findFirstWordIndex", ({ enumerable: true, get: function () { return __importDefault(findFirstWordIndex_1).default; } }));
var getHash_1 = __webpack_require__(93938);
Object.defineProperty(exports, "getHash", ({ enumerable: true, get: function () { return __importDefault(getHash_1).default; } }));
var getTempFilepath_1 = __webpack_require__(5026);
Object.defineProperty(exports, "getTempFilepath", ({ enumerable: true, get: function () { return __importDefault(getTempFilepath_1).default; } }));
var getTxtWordList_1 = __webpack_require__(78029);
Object.defineProperty(exports, "getTxtWordList", ({ enumerable: true, get: function () { return __importDefault(getTxtWordList_1).default; } }));
var latinizeDiacritics_1 = __webpack_require__(41563);
Object.defineProperty(exports, "latinizeDiacritics", ({ enumerable: true, get: function () { return __importDefault(latinizeDiacritics_1).default; } }));
var unique_1 = __webpack_require__(52017);
Object.defineProperty(exports, "unique", ({ enumerable: true, get: function () { return __importDefault(unique_1).default; } }));
var unzip_1 = __webpack_require__(76987);
Object.defineProperty(exports, "unzip", ({ enumerable: true, get: function () { return __importDefault(unzip_1).default; } }));


/***/ }),

/***/ 41563:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const latinize_1 = __importDefault(__webpack_require__(66761));
const unique_1 = __importDefault(__webpack_require__(52017));
const latinizeDiacritics = (words) => {
    return (0, unique_1.default)(words.map((word) => (0, latinize_1.default)(word)));
};
exports["default"] = latinizeDiacritics;


/***/ }),

/***/ 52017:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
const unique = (array) => Array.from(new Set(array));
exports["default"] = unique;


/***/ }),

/***/ 76987:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const fs_1 = __importDefault(__webpack_require__(57147));
const unzipper_1 = __importDefault(__webpack_require__(23428));
const unzip = (zipFilename, extractFilename, outputFilename) => {
    return fs_1.default
        .createReadStream(zipFilename)
        .pipe(unzipper_1.default.Parse())
        .on('entry', (entry) => {
        const fileName = entry.path;
        if (fileName === extractFilename) {
            entry.pipe(fs_1.default.createWriteStream(outputFilename));
        }
        else {
            entry.autodrain();
        }
    })
        .promise();
};
exports["default"] = unzip;


/***/ })

};
;