"use strict";
(() => {
var exports = {};
exports.id = 876;
exports.ids = [876];
exports.modules = {

/***/ 60871:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 39491:
/***/ ((module) => {

module.exports = require("assert");

/***/ }),

/***/ 22057:
/***/ ((module) => {

module.exports = require("constants");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 82361:
/***/ ((module) => {

module.exports = require("events");

/***/ }),

/***/ 57147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 13685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 95687:
/***/ ((module) => {

module.exports = require("https");

/***/ }),

/***/ 22037:
/***/ ((module) => {

module.exports = require("os");

/***/ }),

/***/ 71017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 12781:
/***/ ((module) => {

module.exports = require("stream");

/***/ }),

/***/ 71576:
/***/ ((module) => {

module.exports = require("string_decoder");

/***/ }),

/***/ 76224:
/***/ ((module) => {

module.exports = require("tty");

/***/ }),

/***/ 57310:
/***/ ((module) => {

module.exports = require("url");

/***/ }),

/***/ 73837:
/***/ ((module) => {

module.exports = require("util");

/***/ }),

/***/ 59796:
/***/ ((module) => {

module.exports = require("zlib");

/***/ }),

/***/ 2911:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _scrabble_solver_configs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(27911);
/* harmony import */ var _scrabble_solver_configs__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_scrabble_solver_configs__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scrabble_solver_dictionaries__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(89044);
/* harmony import */ var _scrabble_solver_dictionaries__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_scrabble_solver_dictionaries__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scrabble_solver_logger__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(52954);
/* harmony import */ var _scrabble_solver_logger__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_scrabble_solver_logger__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _scrabble_solver_types__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(46452);
/* harmony import */ var _scrabble_solver_types__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_scrabble_solver_types__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var api__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(84021);
/* harmony import */ var api__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(31210);





const verify = async (request, response)=>{
    const meta = (0,api__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z)(request);
    try {
        const { board , locale  } = parseRequest(request);
        _scrabble_solver_logger__WEBPACK_IMPORTED_MODULE_2___default().info("verify - request", {
            meta,
            payload: {
                board: board.toString(),
                boardBlanksCount: board.getBlanksCount(),
                boardTilesCount: board.getTilesCount(),
                game: request.body.game,
                locale
            }
        });
        const trie = await _scrabble_solver_dictionaries__WEBPACK_IMPORTED_MODULE_1__.dictionaries.get(locale);
        const words = board.getWords().sort((a, b)=>a.localeCompare(b, locale));
        const invalidWords = words.filter((word)=>!trie.has(word));
        const validWords = words.filter((word)=>trie.has(word));
        response.status(200).send({
            invalidWords,
            validWords
        });
    } catch (error) {
        const message = error instanceof Error ? error.message : "Unknown error";
        _scrabble_solver_logger__WEBPACK_IMPORTED_MODULE_2___default().error("verify - error", {
            error,
            meta
        });
        response.status(500).send({
            error: "Server error",
            message
        });
    }
};
const parseRequest = (request)=>{
    const { board: boardJson , game , locale  } = request.body;
    if (!(0,_scrabble_solver_types__WEBPACK_IMPORTED_MODULE_3__.isLocale)(locale)) {
        throw new Error('Invalid "locale" parameter');
    }
    if (!(0,_scrabble_solver_types__WEBPACK_IMPORTED_MODULE_3__.isGame)(game)) {
        throw new Error('Invalid "game" parameter');
    }
    if (!(0,_scrabble_solver_configs__WEBPACK_IMPORTED_MODULE_0__.hasConfig)(game, locale)) {
        throw new Error(`No game "${game}" in "${locale}"`);
    }
    const config = (0,_scrabble_solver_configs__WEBPACK_IMPORTED_MODULE_0__.getConfig)(game, locale);
    if (!(0,_scrabble_solver_types__WEBPACK_IMPORTED_MODULE_3__.isBoardJson)(boardJson) || !(0,api__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .Z)(boardJson, config)) {
        throw new Error('Invalid "board" parameter');
    }
    const board = _scrabble_solver_types__WEBPACK_IMPORTED_MODULE_3__.Board.fromJson(boardJson);
    return {
        board,
        config,
        locale
    };
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (verify);


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [50,907,987,44,911,210], () => (__webpack_exec__(2911)));
module.exports = __webpack_exports__;

})();